using RimWorld;
using System.Collections.Generic;
using Verse;

namespace IdlePowerConsumption
{

    public class CompAffectedByFacilities : IComponent
    {
        public float RequiredPower(CompPowerTrader compPowerTrader, bool inUse)
        {
            float result = 0f;

            if(compPowerTrader.parent.GetComp<RimWorld.CompAffectedByFacilities>() != null)
            {
                List<Thing> linkedFacilities = compPowerTrader.parent.GetComp<RimWorld.CompAffectedByFacilities>().LinkedFacilitiesListForReading;
                foreach(Thing thing in linkedFacilities)
                {
                    ThingWithComps facility = thing as ThingWithComps;
                    if(facility != null)
                    {
                        if(facility.GetComp<CompPowerTrader>() != null)
                        {
                            if(inUse)
                            {
                                facility.GetComp<CompPowerTrader>().PowerOutput = -facility.GetComp<CompPowerTrader>().Props.basePowerConsumption;
                            }
                            else
                            {
                                if(facility.GetComp<CompPowerTrader>().PowerOutput != 0f)
                                {
                                    facility.GetComp<CompPowerTrader>().PowerOutput = 0f;
                                }
                            }

                        }
                    }
                }
            }

            return result;
        }
    }
}