using RimWorld;
using HarmonyLib;

namespace IdlePowerConsumption
{

    public class AutoDoor : IConsumer
    {
        private int updateRate;
        private int updateOffset;

        public AutoDoor(int updateR = 4)
        {
            updateRate = updateR;
            updateOffset = updateRate / 2;
        }

        public float RequiredPower(CompPowerTrader compPowerTrader, int updateTick)
        {
            float result = 0f;

            if((updateTick + updateOffset) % updateRate != 0)
            {
                result = -1f;
            }
            else if(compPowerTrader.parent is Building_Door)
            {
                // Log.Message("Yep, this is an auto door");
                result = 10f;
                Building_Door door = compPowerTrader.parent as Building_Door;

                Traverse doorTraverse = Traverse.Create(door);
                int openTicks = doorTraverse.Field("ticksSinceOpen").GetValue<int>();
                int ticksToOpen = doorTraverse.Property("TicksToOpenNow").GetValue<int>();

                if(openTicks > 0 && openTicks < ticksToOpen)
                {
                    result = compPowerTrader.Props.basePowerConsumption * 10;
                }
            }

            return result;
        }

        public bool CheckComponents(CompPowerTrader compPowerTrader)
        {
            return false;
        }
    }
}