using RimWorld;
using Verse;

namespace IdlePowerConsumption
{

    public class Tickable : IConsumer
    {
        private int updateRate;

        // This is a subcategory consumer
        public Tickable(int updateR = 4)
        {
            updateRate = updateR;
        }

        public float RequiredPower(CompPowerTrader compPowerTrader, int updateTick)
        {
            float result = 20f;

            TickableData tickableConsumerData = IdlePowerConsumption.tickableConsumersRegistry.Data(compPowerTrader);

            if(tickableConsumerData.ticksToConsume > 0)
            {
                if(tickableConsumerData.ticksToConsume > updateRate)
                {
                    result = compPowerTrader.Props.basePowerConsumption * 2;
                    if(Find.TickManager.Paused == false)
                    {
                        tickableConsumerData.IncreaseTicks(-1 * updateRate);
                    }
                }
                else
                {
                    tickableConsumerData.ticksToConsume = 0;
                }
            }

            return result;
        }

        public bool CheckComponents(CompPowerTrader compPowerTrader)
        {
            return true;
        }
    }
}