using RimWorld;
using Verse;
using HarmonyLib;

namespace IdlePowerConsumption
{
    //void TryOpenComms(Pawn negotiator);
    [HarmonyPatch(typeof(Faction))]
    [HarmonyPatch("TryOpenComms")]
    public static class Faction_TryOpenComms_Patch
    {

        [HarmonyPostfix]
        public static void TryOpenComms_Postfix(Pawn negotiator)
        {
            CommsConsoleUtil.UpdateCommsConsole(negotiator);
        }
    }

    //void TryOpenComms(Pawn negotiator);
    [HarmonyPatch(typeof(TradeShip))]
    [HarmonyPatch("TryOpenComms")]
    public static class TradeShip_TryOpenComms_Patch
    {

        [HarmonyPostfix]
        public static void TryOpenComms_Postfix(Pawn negotiator)
        {
            CommsConsoleUtil.UpdateCommsConsole(negotiator);
        }
    }

    public static class CommsConsoleUtil
    {
        public static void UpdateCommsConsole(Pawn pawn)
        {
            foreach(Building building in pawn.Map.listerBuildings.allBuildingsColonist)
            {
                if(building.def.defName == "CommsConsole")
                {
                    if(pawn.Position.Equals(building.InteractionCell))
                    {
                        CompPowerTrader compPowerTrader = building.TryGetComp<CompPowerTrader>();
                        if(compPowerTrader != null && compPowerTrader.PowerOn)
                        {
                            IdlePowerConsumption.tickableConsumersRegistry.Data(compPowerTrader).IncreaseTicks(300);
                            break;
                        }
                    }
                }
            }
        }
    }
}